#!/usr/bin/env awk

BEGIN {
  FS = "[: ]"
  total = 0
}
{
  #print "NF: " NF
  sum = $1
  num_opers = 2
  #print "sum: " sum
  num_of_nums = NF - 2
  num_of_results = 1
  #print "num_of_results: " num_of_results
  #print "num_of_nums: " num_of_nums

  # Create list of numbers
  # Create list of results
  for (i = 3; i <= NF; i++) {
    nums[i-2] = $i
  }
  results[1] = nums[1]
  for ( key in nums ) {
    print "key: " key " value: " nums[key]
  }
  # Starting applying additions to results
  # Starting from second number
  for (i = 2; i <= num_of_nums; i++) {
    number = nums[i] 
    for (j = 1; j <= num_of_results; j++) {
      element = results[j]
      results[j+num_of_results] = element * number
      results[j] = results[j] + number
    }
    num_of_results *= num_opers
    print "num_of_results: " num_of_results
  }
  for ( key in results ) {
    print "results key: " key " value: " results[key]
  }
  expected = ( num_of_nums - 1 ) * num_opers
  print "number of operators: " num_of_nums - 1
  print "expect: " expected " num_of_results: " num_of_results

  # Check results
  for (i=1; i <= num_of_results; i++) {
    if ( results[i] == $1 ) {
      print "Index match found: " i ":" results[i] ":" $1 " num_of_nums: " num_of_nums
      start_val = i % num_of_nums
      stack_num = (i - start_val) / num_of_nums
      print "Starting value: " nums[start_val]
      total = total + $1
      break
    }
  }
  delete results
  delete nums
}
END {
  print total
}
